package solatium.rest;

import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.extern.slf4j.Slf4j;
import solatium.auth.Verification;
import solatium.gui.HomeScreen;
import solatium.interfaces.Customer;
import solatium.interfaces.UserDataBase;
import sun.misc.IOUtils;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

import static spark.Spark.*;

@Slf4j
public class MainController {

    public MainController() {
        get("/test", (req, res) -> {
            log.info("Active Thread count: " + Thread.activeCount() + " " + Thread.currentThread().getName());
            return "test";
        });

        get("/", (req, res) -> {
            log.info("Active Thread count: " + Thread.activeCount() + " " + Thread.currentThread().getName());
            return read("public/index.html");
        });

        post("/login", (req, res) -> {
            LoginData data = new ObjectMapper().readValue(req.body(), LoginData.class);
            Verification auth = new Verification(new UserDataBase());

            boolean isAuth = auth.verifiy(data.getUsername(), data.getPassword());

            if(isAuth) {
                return "ok";
            } else {
                return "Wrong Credentials";
            }
        });
    }

    private String read(String file) {
        StringBuilder contentBuilder = new StringBuilder();
        try {
            BufferedReader in = new BufferedReader(new FileReader(file));
            String str;
            while ((str = in.readLine()) != null) {
                contentBuilder.append(str);
            }
            in.close();
        } catch (IOException e) {
        }
        String content = contentBuilder.toString();

        return content;
    }
}
